Main (Java SE 21 & JDK 21)
Description: declaration: module: jdk.compiler, package: com.sun.tools.javac, class: Main
Keywords: com.sun.tools.javac.Main class

Module jdk.compiler
Package com.sun.tools.javac

# Class Main

java.lang.Object
com.sun.tools.javac.Main

public class Main extends Object
A legacy programmatic interface for the Java Programming Language compiler, javac. See the `jdk.compiler` module for details on replacement APIs.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Main()`
  Deprecated, for removal: This API element is subject to removal in a future version.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `compile(String[] args)`
  Programmatic interface to the Java Programming Language compiler, javac.
  `static int`
  `compile(String[] args, PrintWriter out)`
  Programmatic interface to the Java Programming Language compiler, javac.
  `static void`
  `main(String[] args)`
  Main entry point for the launcher.

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Main

    @Deprecated(since="16", forRemoval=true) public Main()
    Deprecated, for removal: This API element is subject to removal in a future version.
    Do not call.

- ## Method Details

  - ### main

    public static void main(String[] args) throws Exception
    Main entry point for the launcher. Note: This method calls System.exit.
    Parameters:
      `args` - command line arguments
    Throws:
      `Exception` - only if an uncaught internal exception occurs; just retained for historical compatibility

  - ### compile

    public static int compile(String[] args)
    Programmatic interface to the Java Programming Language compiler, javac.
    Parameters:
      `args` - The command line arguments that would normally be passed to the javac program as described in the man page.
    Returns:
      an integer equivalent to the exit value from invoking javac, see the man page for details.

  - ### compile

    public static int compile(String[] args, PrintWriter out)
    Programmatic interface to the Java Programming Language compiler, javac.
    Parameters:
      `args` - The command line arguments that would normally be passed to the javac program as described in the man page.
      `out` - PrintWriter to which the compiler's diagnostic output is directed.
    Returns:
      an integer equivalent to the exit value from invoking javac, see the man page for details.